.\"
.\" $Id: nuu.man,v 1.11.1 2015/06/17 09:37:26 todd $
.\"
.TH NUU 1 "17 Jun 2015" "1.11.1"
.SH NAME 
nuu \- Network Update Utility
.SH SYNOPSIS
.B nuu
\fI[options...]\fP
.SH DESCRIPTION
.I nuu
(Network Update Utility) is a graphical user interface which allows a
user to make modifications to the installed rpm packages on a system.

Its capabilities are:
.nr P2 \n(PD
.nr PD 0
.IP \ \ \ \ \(bu
Install new packages or update existing packages by downloading them from a 
yum package repository
.IP \ \ \ \ \(bu
Remove existing packages
.IP \ \ \ \ \(bu
Configure sets of repositories from which to obtain new and updated packages
.IP \ \ \ \ \(bu
Examine installed packages or packages available for installation or update
.IP \ \ \ \ \(bu
Install, update, or remove groups of packages
.IP \ \ \ \ \(bu
Install or update suites of packages
.nr PD \n(P2
.SH OPTIONS
.PP
.I nuu
accepts the following command line arguments:
.TP 8
.I -m m, --mode=m
Start with the package table mode, m, where m is one of: filter, search,
or any abbreviation thereof.
.TP 8
.I -e r, --regexp=r
Start with the package table regexp
.TP 8
.I -s s, --state=s
Start with the package table state, s, where s is one of:
updatable, installable, removable, all,
or any abbreviation thereof.
.TP 8
.I -g, --groups
Start with the package table show groups.
.TP 8
.I -r, --repo-editor
Start by bringing up the repository configuration editor.  Use this to edit the 
repositories before attempting to read information from them.
.TP 8
.I -l, --log
Start with the log window displayed.
.TP 8
.I --disablerepo=r
Disable the specified repository, r.
.TP 8
.I --enablerepo=r
Enable the specified repository, r.
.SH ACKNOWLEDGMENTS
.I nuu
is based on Yum, the Yellowdog Updater Modified.  It also uses the python,
rpm-libs, rpm-python, and qt4 libraries.  Images were created with inkscape.
.SH COPYRIGHT
Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015
Concurrent Computer Corporation.
This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License Version 2 (GPLv2), which should be
included with this software.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

For other license arrangements, contact Concurrent Computer Corporation.
.SH AUTHOR
Todd Allen, Concurrent Computer Corporation <nuu@etallen.com>
.SH SEE ALSO
.I yum(8), yum.conf(5)
.br
http://redhawk.ccur.com/nuu
